#!/usr/bin/env python2.2
import sys,portage,os
from qt import *
from editorgui import *

app=QApplication([])
win=Form1()
def main(args):
	win.show()
	app.connect(app, SIGNAL("lastWindowClosed()"), app, SLOT("quit()"))
	app.connect(win.bnQuit, SIGNAL("clicked()"), close)
	app.connect(win.bnAddRev, SIGNAL("clicked()"), addRev)
	app.connect(win.cbCat, SIGNAL("textChanged(const QString&)"), pkgUpdate)
	app.connect(win.cbPkg, SIGNAL("textChanged(const QString&)"), verUpdate)
	app.connect(win.cbVer, SIGNAL("textChanged(const QString&)"), revUpdate)
	app.connect(win.cbRev, SIGNAL("textChanged(const QString&)"), loadData)
	app.connect(win.bnRevert, SIGNAL("clicked()"), loadData)
	app.connect(win.bnSave, SIGNAL("clicked()"), saveData)
	app.connect(win.kwrite, SIGNAL("clicked()"), kwrite)
	app.connect(win.gedit, SIGNAL("clicked()"), gedit)
	app.connect(win.mp, SIGNAL("clicked()"), mp)
	app.connect(win.nano, SIGNAL("clicked()"), nano)
	app.connect(win.vim, SIGNAL("clicked()"), vim)
	loadLicences()
	catUpdate()
	app.exec_loop()


cpall=portage.portdb.cp_all()
cpall.sort()
licenses=os.listdir("/usr/portage/licenses")
licenses.sort()
pkglst=[]
fileName=""
portdir=portage.settings["PORTDIR"]
overdir=portage.settings["PORTDIR_OVERLAY"]

def catUpdate():
	cats=[]
	win.cbCat.clear()
	for cat in cpall:
		cat=cat.split("/")[0]
		if cat not in cats:
			cats.append(cat)
			win.cbCat.insertItem(cat)


def pkgUpdate():
	win.cbPkg.clear()
	for pkg in cpall:
		if pkg.split('/')[0]== str(win.cbCat.currentText()):
			win.cbPkg.insertItem(pkg.split('/')[1])

def verUpdate():
	global plist
	plist=portage.portdb.p_list(str(win.cbCat.currentText())+"/"+str(win.cbPkg.currentText()))
	plist.sort()
	plist.reverse()

	vers=[]
	win.cbVer.clear()
	for ebuild in plist:
		ver=portage.pkgsplit(ebuild)[1]
		if ver not in vers:
			vers.append(ver)
			win.cbVer.insertItem(ver)

def revUpdate():
	win.cbRev.clear()
	for ebuild in plist:
		if portage.pkgsplit(ebuild)[1] == str(win.cbVer.currentText()):
			win.cbRev.insertItem(portage.pkgsplit(ebuild)[2][1:])

def addRev():
	win.cbRev.insertItem(str(int(str(win.cbRev.text(0)))+1),0)

def loadData():
	if win.cbRev.count():
		global cpv
		global fileName
		if str(win.cbRev.currentText()) != "0":
			cpv=str(win.cbCat.currentText())+"/"+str(win.cbPkg.currentText())+"-"
			cpv+=str(win.cbVer.currentText())+"-r"+str(win.cbRev.currentText())
		else:
			cpv=str(win.cbCat.currentText())+"/"+str(win.cbPkg.currentText())+"-"
			cpv+=str(win.cbVer.currentText())

		fileName=portage.portdb.findname(cpv)
		vars=loadFile(fileName)
		if fileName[:len(portdir)]==portdir:
			win.chkOverlay.setChecked(0)
		else:
			win.chkOverlay.setChecked(1)

		win.fileName.setText(fileName)
		win.DESCRIPTION.setText(vars[0])
		win.HOMEPAGE.setText(vars[1])
		win.SRC_URI.setText(vars[2])
		win.IUSE.setText(vars[3])
		win.DEPEND.setText(vars[4])
		win.RDEPEND.setText(vars[5])
		win.SLOT.setText(vars[6])
		win.LICENSE.setCurrentText(vars[7])

		keywords=" "+vars[8]
		masks=[]
		archs=["x86","ppc","alpha","sparc","amd64","mips","arm","hppa"]
		for arch in archs:
			if keywords.count(arch):
				arch=keywords.split(arch)[0][-1]

				if arch==" ":
					masks.append(1)
				elif arch=="~":
					masks.append(2)
				elif arch=="-":
					masks.append(3)
			else:
				masks.append(0)

		win.mskX86.setCurrentItem(masks[0])
		win.mskPpc.setCurrentItem(masks[1])
		win.mskAlpha.setCurrentItem(masks[2])
		win.mskSparc.setCurrentItem(masks[3])
		win.mskAmd64.setCurrentItem(masks[4])
		win.mskMips.setCurrentItem(masks[5])
		win.mskArm.setCurrentItem(masks[6])
		win.mskHppa.setCurrentItem(masks[7])

		if keywords.count("-*"):
			win.mskMinus.setChecked(1)
		else:
			win.mskMinus.setChecked(0)

		masked=0
		for line in file("/usr/portage/profiles/package.mask").readlines():
			if line != "":
				if line[0] != "#" and line.count(str(win.cbPkg.currentText())):
					 if cpv in portage.portdb.match2(line,portage.dep_getkey(line),[cpv]):
					 	masked=1
		win.mskHard.setChecked(masked)
def kwrite():
	os.system("kwrite " + filename)
	addPkg()

def gedit():
	os.system("gedit " + str(win.fileName.text()))
	addPkg()

def mp():
	os.system("xterm -fg white -bg black -e mp -mouse -m sh " + str(win.fileName.text()))
	addPkg()
def nano():
	os.system("xterm -fg white -bg black -e nano " + str(win.fileName.text()))
	addPkg()

def vim():
	os.system("xterm -fg white -bg black -e vim " + str(win.fileName.text()))
	addPkg()

def loadLicences():
	win.LICENSE.clear()
	win.LICENSE.insertStrList(licenses)

def addPkg():
	pkglst.append(cpv)
	loadData()

def saveData():

	vars=[]
	vars.append(str(win.DESCRIPTION.text()))
	vars.append(str(win.HOMEPAGE.text()))
	vars.append(str(win.SRC_URI.text()))
	vars.append(str(win.IUSE.text()))
	vars.append(str(win.DEPEND.text()))
	vars.append(str(win.RDEPEND.text()))
	vars.append(str(win.SLOT.text()))
	vars.append(str(win.LICENSE.currentText()))


	masks=[]
	keywords=""

	masks.append(str(win.mskX86.currentText()))
	masks.append(str(win.mskPpc.currentText()))
	masks.append(str(win.mskAlpha.currentText()))
	masks.append(str(win.mskSparc.currentText()))
	masks.append(str(win.mskAmd64.currentText()))
	masks.append(str(win.mskMips.currentText()))
	masks.append(str(win.mskArm.currentText()))
	masks.append(str(win.mskHppa.currentText()))

	archs=["x86","ppc","alpha","sparc","amd64","mips","arm","hppa"]
	for count in range(len(archs)):
			arch=archs[count]
			mask=masks[count][0]

			if mask=="L":
				keywords+=arch+" "
			elif mask=="U":
				keywords+=""

			else:
				keywords+=mask+arch+" "



	if win.mskMinus.isChecked():
		keywords += "-*"

	vars.append(keywords)

	for varcount in range(len(vars)):
		firstline=1
		tmp=""
		for line in vars[varcount].split(" @"):
			if firstline:
				tmp+=line
				firstline=0
			else:
				tmp+="\n\t " + line
		vars[varcount]=tmp

	varcount=0
	lines=file(filename).readlines()

	keys = ["DESCRIPTION","HOMEPAGE","SRC_URI","IUSE","DEPEND","RDEPEND","SLOT","LICENSE","KEYWORDS"]
	for var in keys:
		vars[keys.index(var)]= var + "=\"" + vars[keys.index(var)] +"\"\n"
		linecount=0
		inquote=0
		startline=endline=-1
		for line in lines:

			if not inquote:
				if line[:3] == var[:3]:
					startline=linecount
					if line.count("\"")==1:
						inquote=1
					else:
						endline=linecount
			else:
				if line.count("\"")==1:
						inquote=0
						endline=linecount

			linecount+=1
		lines=insertLines(startline, endline, lines, [vars[varcount]])
		varcount+=1

	file(fileName, "w").writelines(lines)
	addPkg()


def insertLines(startline, endline, oldlines, newlines):
	lines=[]
	if startline != -1:
		for line in oldlines[0:startline]:
			lines.append(line)
	for line in newlines:
		lines.append(line)
	for line in oldlines[endline+1:]:
		lines.append(line)
	return lines


def close():
	app.quit()
	win.hide()
	if pkglst != [] and ("cdb" or "dict") in portage.features:
		portage.portdb.addPkg(pkglst)
		pass
		
def loadFile(fileName):
	lines=portage.grabfile(fileName)
	keys = ["DESCRIPTION","HOMEPAGE","SRC_URI","IUSE","DEPEND","RDEPEND","SLOT","LICENSE","KEYWORDS"]
	vars=[]
	for key in keys:
		var=""
		inquote=0
		for line in lines:
			if line.split("=")[0] == key:
				if not inquote:
					var=line.split("\"")[1]
					if line.count("\"")==1:
						inquote=1
					else:
						break
			elif inquote:
				var+=" @"+line.split("\"")[0]
				if line.count("\"")==1:
					inquote=0
					break
		vars.append(var)
	return vars


if __name__=="__main__":
	main(sys.argv)


